-------------------------------------------
--- AddOn: Ketho CombatLog				---
--- Author: Ketho (EU-Boulderfist)		---
--- Created: 2009.09.01					---
--- License: Public Domain				---
-------------------------------------------
--- Ketho CombatLog	v0.94 [2011.03.29]	---
--- Ace3 Framework	r1009 [2011.02.09]	---
-------------------------------------------
--- Curse			http://wow.curse.com/downloads/wow-addons/details/ketho-combatlog.aspx
--- WoWInterface	http://www.wowinterface.com/downloads/info18901-KethoCombatLog.html

--- I don't have any previous programming experience or background in any (scripting) language
--- Note: This is my first AddOn

-- http://www.wowace.com/addons/ace3/pages/api/ace-addon-3-0/
KethoCombatLog = LibStub("AceAddon-3.0"):NewAddon("KethoCombatLog", "AceEvent-3.0", "AceTimer-3.0", "AceConsole-3.0")
local KCL = KethoCombatLog
local ACR = LibStub("AceConfigRegistry-3.0")
local ACD = LibStub("AceConfigDialog-3.0")

-- http://www.wowace.com/addons/ace3/pages/api/ace-locale-3-0/
local L = LibStub("AceLocale-3.0"):GetLocale("KethoCombatLogLocale", true)

	--------------------
	--- 01  UPVALUES ---
	--------------------
	
local _G = _G -- global table

--# Lua APIs
-- http://www.wowpedia.org/Lua_functions
-- http://www.lua.org/manual/5.1/
local print = print
local pairs, type = pairs, type
local tonumber = tonumber
local unpack, select = unpack, select
local time = time -- os.date, os.time (mirrored)
local format = format -- string.format, string.gsub
local strsub = strsub -- string.sub
local band = bit.band -- BitLib library

--# WoW APIs
-- http://www.wowpedia.org/World_of_Warcraft_API
-- http://wowprogramming.com/docs/api
local GetTime = GetTime
local UnitName, UnitClass = UnitName, UnitClass
local UnitInParty, UnitInRaid = UnitInParty, UnitInRaid
local UnitGroupRolesAssigned = UnitGroupRolesAssigned
local IsInInstance = IsInInstance
local SCM = SendChatMessage

--# File-local scope variables
-- http://www.wowpedia.org/UnitFlag
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY -- 16(decimal) == 01000000(binary)
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8

-- http://wowprogramming.com/utils/xmlbrowser/live/AddOns/Blizzard_CombatLog/Blizzard_CombatLog.lua
local STRING_SCHOOL_PHYSICAL = STRING_SCHOOL_PHYSICAL
local STRING_SCHOOL_HOLY = STRING_SCHOOL_HOLY
local STRING_SCHOOL_FIRE = STRING_SCHOOL_FIRE
local STRING_SCHOOL_NATURE = STRING_SCHOOL_NATURE
local STRING_SCHOOL_FROST = STRING_SCHOOL_FROST
local STRING_SCHOOL_SHADOW = STRING_SCHOOL_SHADOW
local STRING_SCHOOL_ARCANE = STRING_SCHOOL_ARCANE
local STRING_SCHOOL_HOLYSTRIKE = STRING_SCHOOL_HOLYSTRIKE
local STRING_SCHOOL_FLAMESTRIKE = STRING_SCHOOL_FLAMESTRIKE
local STRING_SCHOOL_HOLYFIRE = STRING_SCHOOL_HOLYFIRE
local STRING_SCHOOL_STORMSTRIKE = STRING_SCHOOL_STORMSTRIKE
local STRING_SCHOOL_HOLYSTORM = STRING_SCHOOL_HOLYSTORM
local STRING_SCHOOL_FIRESTORM = STRING_SCHOOL_FIRESTORM
local STRING_SCHOOL_FROSTSTRIKE = STRING_SCHOOL_FROSTSTRIKE
local STRING_SCHOOL_HOLYFROST = STRING_SCHOOL_HOLYFROST
local STRING_SCHOOL_FROSTFIRE = STRING_SCHOOL_FROSTFIRE
local STRING_SCHOOL_FROSTSTORM = STRING_SCHOOL_FROSTSTORM
local STRING_SCHOOL_SHADOWSTRIKE = STRING_SCHOOL_SHADOWSTRIKE
local STRING_SCHOOL_SHADOWLIGHT = STRING_SCHOOL_SHADOWLIGHT -- Twilight
local STRING_SCHOOL_SHADOWFLAME = STRING_SCHOOL_SHADOWFLAME
local STRING_SCHOOL_SHADOWSTORM = STRING_SCHOOL_SHADOWSTORM -- Plague
local STRING_SCHOOL_SHADOWFROST = STRING_SCHOOL_SHADOWFROST
local STRING_SCHOOL_SPELLSTRIKE = STRING_SCHOOL_SPELLSTRIKE
local STRING_SCHOOL_DIVINE = STRING_SCHOOL_DIVINE
local STRING_SCHOOL_SPELLFIRE = STRING_SCHOOL_SPELLFIRE	
local STRING_SCHOOL_SPELLSTORM = STRING_SCHOOL_SPELLSTORM
local STRING_SCHOOL_SPELLFROST = STRING_SCHOOL_SPELLFROST
local STRING_SCHOOL_SPELLSHADOW = STRING_SCHOOL_SPELLSHADOW
local STRING_SCHOOL_ELEMENTAL = STRING_SCHOOL_ELEMENTAL
local STRING_SCHOOL_CHROMATIC = STRING_SCHOOL_CHROMATIC
local STRING_SCHOOL_MAGIC = STRING_SCHOOL_MAGIC
local STRING_SCHOOL_CHAOS = STRING_SCHOOL_CHAOS
local STRING_SCHOOL_UNKNOWN = STRING_SCHOOL_UNKNOWN

-- http://wowprogramming.com/utils/xmlbrowser/live/FrameXML/GlobalStrings.lua
local ACTION_SWING = ACTION_SWING
local ACTION_SPELL_INTERRUPT = ACTION_SPELL_INTERRUPT
local ACTION_SPELL_DISPEL_BUFF = ACTION_SPELL_DISPEL_BUFF
local ACTION_SPELL_DISPEL_DEBUFF = ACTION_SPELL_DISPEL_DEBUFF
local ACTION_SPELL_STOLEN = ACTION_SPELL_STOLEN
local ACTION_SPELL_MISSED_REFLECT = ACTION_SPELL_MISSED_REFLECT
local ACTION_UNIT_DIED = ACTION_UNIT_DIED
local ACTION_SPELL_RESURRECT = ACTION_SPELL_RESURRECT
local ACTION_SPELL_CAST_FAILED = ACTION_SPELL_CAST_FAILED
local ACTION_SPELL_MISSED_MISS = ACTION_SPELL_MISSED_MISS
local ACTION_SPELL_MISSED_IMMUNE = ACTION_SPELL_MISSED_IMMUNE
local COMBAT_TEXT_RESIST = COMBAT_TEXT_RESIST
local TEXT_MODE_A_STRING_RESULT_OVERKILLING = TEXT_MODE_A_STRING_RESULT_OVERKILLING
local TEXT_MODE_A_STRING_RESULT_CRITICAL = TEXT_MODE_A_STRING_RESULT_CRITICAL
local TEXT_MODE_A_STRING_RESULT_CRUSHING = TEXT_MODE_A_STRING_RESULT_CRUSHING
local YOU, QUICKBUTTON_NAME_SELF = YOU, QUICKBUTTON_NAME_SELF

local profile, char, color
local CF -- ChatFrameN
local instanceType, announceType, lastDeath, playerColor

-- http://www.wowpedia.org/UI_escape_sequences
local iconCropped = "64:64:4:60:4:60"
local timeSilence = 0

local player = {
	Name = UnitName("player"),
	Class = select(2, UnitClass("player")),
}

local Taunt = {
-- Warrior
	355, -- Taunt
-- Paladin
	62124, -- Hand of Reckoning
	31790, -- Righteous Defense
-- Druid
	6795, -- Growl
-- Death Knight
	56222, -- Dark Command
	49560, -- Death Grip
	51399, -- Death Grip (melee range)
-- Hunter
	20736, -- Distracting Shot
-- Warlock	
	17735, -- Suffering [Voidwalker]
}

local CrowdControl = {
-- Mage
	118, -- Polymorph
	61305, -- Polymorph - Black Cat
	28272, -- Polymorph - Pig
	61721, -- Polymorph - Rabbit
	61780, -- Polymorph - Turkey
	28271, -- Polymorph - Turtle
-- Rogue
	6770, -- Sap
	2094, -- Blind
-- Hunter
	3355, -- Freezing Trap
	1513, -- Scare Beast
	19386, -- Wyvern Sting
-- Priest
	9484, -- Shackle Undead
-- Paladin
	10326, -- Turn Evil
	20066, -- Repentance
-- Warlock
	710, -- Banish
	5782, -- Fear
	6358, -- Seduction [Succubus]
-- Druid
	2637, -- Hibernate
	33786, -- Cyclone
-- Shaman
	51514, -- Hex
	76780, -- Bind Elemental
}

local cd = { -- Cooldown / Throttle
	instanceType = 0,
	Death = 0,
	Bloodlust = 0,
	RitualRefreshment = 0,
}

	------------------------------
	--- 02  Options & Defaults ---
	------------------------------

local defaults = {
	profile = { -- KethoCombatLog.db.defaults.profile
		enableAddOn = true,
		Taunt = true,
		Death = true,
		PvE = true,
		color = {
			Taunt = {1, 0, 0}, -- #FF0000 (Red)
			Interrupt = {0, 110/255, 1}, -- #006EFF
			Dispel = {1, 1, 1},
			Reflect = {1, 1, 1},
			CrowdControl = {1, 1, 1},
			CC_Break = {1, 1, 1},
			Death = {1, 1, 1},
			Resurrection = {175/255, 1, 47/255}, -- #ADFF2F (GreenYellow)
		--	http://www.wowpedia.org/API_COMBAT_LOG_EVENT#Spell_School
			Physical = {1.00, 1.00, 0.00}, -- #FFFF00
			Holy = {1.00, 0.90, 0.50}, -- #FFE680
			Fire = {1.00, 0.50, 0.00}, -- #FF8000
			Nature = {0.30, 1.00, 0.30}, -- #4DFF4D
			Frost = {0.50, 1.00, 1.00}, -- #80FFFF
			Shadow = {0.50, 0.50, 1.00}, -- #8080FF
			Arcane = {1.00, 0.50, 1.00}, -- #FF80FF
		--	http://www.wowpedia.org/Class_colors
			DeathKnight = {0.77, 0.12, 0.23}, -- #C41F3B
			Druid = {1.00 , 0.49, 0.04}, -- #FF7D0A
			Hunter = {0.67, 0.83, 0.45}, -- #ABD473
			Mage = {0.41, 0.80, 0.94}, -- #69CCF0
			Paladin = {0.96, 0.55, 0.73}, -- #F58CBA
			Priest = {1.00, 1.00, 1.00}, -- #FFFFFF
			Rogue = {1.00, 0.96, 0.41}, -- #FFF569
			Shaman = {0.00, 0.44, 0.87}, -- #0070DE
			Warlock = {0.58, 0.51, 0.79}, -- #9482C9
			Warrior = {0.78, 0.61, 0.43}, -- #C79C6E
			Friendly = {0.34, 0.64, 1.00}, -- #57A3FF -- /dump COMBATLOG_DEFAULT_COLORS.unitColoring[32542]
			Hostile = {0.75, 0.05, 0.05}, -- #BF0D0D
			Unknown = {191/255, 191/255, 191/255}, -- #BFBFBF
		},
		iconSize = 16,
		iconCropped = true,
		BlizzardCombatLog = true,
		abilityExcludeSelf = true,
	},
	char = {
		chatWindow = 2, -- ChatFrame1
		chatChannel = 1, -- Disabled
	},
}

--- Blizzard GUI Options --- http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
local options = {
	type = "group",
	name = "",
	args = {
		Main = {
			type = "group",
			name = "\124cffADFF2FKetho\124r |cffFFFFFFCombatLog|r |cffB6CA00v0.94|r", -- Main Options Header
			handler = KCL,
			args = {
				toggleEnableAddOn = {
					type = "toggle",
					order = 1,
					width = "full",
					descStyle = "",
					name = "|cffFFFFFFEnable AddOn|r",
					get = function(i) return profile.enableAddOn end,
					set = function(i, v) profile.enableAddOn = v
						if v then KCL:Enable() -- Turn AddOn on
						else KCL:Disable() -- Turn AddOn off
						end
					end,
				},
				toggleTaunt = {
					type = "toggle",
					order = 2,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Nature_Reincarnation:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.Taunt))..GetSpellInfo(355).."|r" end,
					get = function(i) return profile.Taunt end,
					set = function(i, v) profile.Taunt = v end,
				},
				toggleCrowdControl = {
					type = "toggle",
					order = 3,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Nature_Polymorph:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.CrowdControl)).."Crowd Control|r" end,
					get = function(i) return profile.CrowdControl end,
					set = function(i, v) profile.CrowdControl = v end,
				},
			--	force newline for Blizzard/AceConfigDialog "wide" Options Window  http://forums.wowace.com/showthread.php?p=312303
				newline01 = {type = "description", order = 4, name = ""},
				toggleInterrupt = {
					type = "toggle",
					order = 5,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Kick:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.Interrupt))..INTERRUPT.."|r" end,
					get = function(i) return profile.Interrupt end,
					set = function(i, v) profile.Interrupt = v end,
				},
				toggleCC_Break = {
					type = "toggle",
					order = 6,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Seal:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.CC_Break)).."CC Breaker|r" end,
					get = function(i) return profile.CC_Break end,
					set = function(i, v) profile.CC_Break = v end,
				},
				newline02 = {type = "description", order = 7, name = ""},
				toggleDispel = {
					type = "toggle",
					order = 8,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Holy_DispelMagic:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.Dispel))..GetSpellInfo(25808).."|r" end,
					get = function(i) return profile.Dispel end,
					set = function(i, v) profile.Dispel = v end,
				},
				toggleDeath = {
					type = "toggle",
					order = 9,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Rogue_FeignDeath:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.Death))..TUTORIAL_TITLE25.."|r" end,
					get = function(i) return profile.Death end,
					set = function(i, v) profile.Death = v end,
				},
				newline03 = {type = "description", order = 10, name = ""},
				toggleReflect = {
					type = "toggle",
					order = 11,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.Reflect))..REFLECT.."|r" end,
					get = function(i) return profile.Reflect end,
					set = function(i, v) profile.Reflect = v end,
				},
				toggleResurrection = {
					type = "toggle",
					order = 12,
					descStyle = "",
					disabled = "OptionsDisabled",
					name = function() return "|TInterface\\Icons\\Spell_Holy_Resurrection:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(unpack(profile.color.Resurrection))..GetSpellInfo(2006).."|r" end,
					get = function(i) return profile.Resurrection end,
					set = function(i, v) profile.Resurrection = v end,
				},
				newline04 = {type = "description", order = 13, name = ""},
				header01 = {
					type = "header",
					order = 14,
					name = "",
				},
				togglePvE = {
					type = "toggle",
					order = 15,
					descStyle = "",
					name = "  |cffA8A8FFPvE|r", -- /dump ChatTypeInfo.PARTY {r = 0.666, g = 0.666, b = 1.000}
					disabled = "OptionsDisabled",
					get = function(i) return profile.PvE end,
					set = function(i, v) profile.PvE = v end,
				},
				toggleTankTaunt = {
					type = "toggle",
					order = 16,
					descStyle = "",
					name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:28:28:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Spell_Nature_Reincarnation:24:24:0:0:"..iconCropped.."|t |cff6FAFE6"..TANK.."|r |cff"..KCL_Dec2Hex(unpack(profile.color.Taunt)).."Taunts|r" end,
					disabled = function() return not profile.Taunt or not profile.enableAddOn end,
					get = function(i) return profile.TankTaunt end,
					set = function(i, v) profile.TankTaunt = v end,
				},
				newline05 = {type = "description", order = 17, name = ""},
				togglePvP = {
					type = "toggle",
					order = 18,
					descStyle = "",
					name = "  |cffFF7F00"..PVP.."|r", -- /dump ChatTypeInfo.RAID {r = 1.000, g = 0.498, b = 0.000}
					disabled = "OptionsDisabled",
					get = function(i) return profile.PvP end,
					set = function(i, v) profile.PvP = v end,
				},
				toggleTankBreak = {
					type = "toggle",
					order = 19,
					descStyle = "",
					name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:28:28:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Ability_Seal:24:24:0:0:"..iconCropped.."|t |cff6FAFE6"..TANK.."|r |cff"..KCL_Dec2Hex(unpack(profile.color.CC_Break)).."CC Breaks|r" end,
					disabled = function() return not profile.CC_Break or not profile.enableAddOn end,
					get = function(i) return profile.TankBreak end,
					set = function(i, v) profile.TankBreak = v end,
				},
				newline06 = {type = "description", order = 20, name = ""},
				toggleWorld = {
					type = "toggle",
					order = 21,
					descStyle = "",
					name = "  World",
					disabled = "OptionsDisabled",
					get = function(i) return profile.World end,
					set = function(i, v) profile.World = v end,
				},
				togglePetGrowl = {
					type = "toggle",
					order = 22,
					descStyle = "",
					name = function() return " |TInterface\\Icons\\INV_Weapon_Bow_07:24:24:-4:0:"..iconCropped.."|t|TInterface\\Icons\\Ability_Physical_Taunt:24:24:1:0:"..iconCropped.."|t  |cffABD473"..PET.."|r |cff"..KCL_Dec2Hex(unpack(profile.color.Taunt))..GetSpellInfo(2649).."|r" end,
					disabled = function() return not profile.Taunt or not profile.enableAddOn end,
					get = function(i) return profile.PetGrowl end,
					set = function(i, v) profile.PetGrowl = v end,
				},
				newline07 = {type = "description", order = 23, name = ""},
				header02 = {
					type = "header",
					order = 24,
					name = "",
				},
				selectChatWindow = {
					type = "select",
					order = 25,
					descStyle = "",
					name = "   |cffFFFFFF"..CHAT.." Window|r",
					disabled = "OptionsDisabled",
					values = function()
						local ChatWindowList = {}
						ChatWindowList[1] = "|cffFF0000<"..ADDON_DISABLED..">|r"
						for i = 1, NUM_CHAT_WINDOWS do
							local a = GetChatWindowInfo(i)
							if a ~= "" then ChatWindowList[i+1] = "|cff2E9AFE"..i..".|r  "..select(1, GetChatWindowInfo(i)) end
						end
						return ChatWindowList end,
					get = function(i) return char.chatWindow end,
					set = function(i, v) char.chatWindow = v
						if v > 1 then
							CF = _G["ChatFrame"..v-1]
							CF:AddMessage("|cffADFF2FKetho CombatLog|r: Chat Frame |cff57A3FF"..(v-1)..".|r |cffADFF2F"..GetChatWindowInfo(v-1).."|r")
						end
					end,
				},
				selectChatChannel = {
					type = "select",
					order = 26,
					descStyle = "",
					name = "   |cffFFFFFF"..CHAT.." "..CHANNEL.."|r",
					values = function() local ChatChannelList = {}
						ChatChannelList[1] = "|cffFF0000<"..ADDON_DISABLED..">|r"
						ChatChannelList[2] = "|cff2E9AFE#|r   "..CHAT_MSG_SAY
						ChatChannelList[3] = "|cff2E9AFE#|r   |cffFF4040"..CHAT_MSG_YELL.."|r"
						ChatChannelList[4] = "|cff2E9AFE#|r   |cffA8A8FF"..CHAT_MSG_PARTY.."|r / |cffFF7F00"..CHAT_MSG_RAID.."|r"
						for i = 1, 10 do
							local a = select((i*2)-1, GetChannelList()) -- this is was kinda hard to code, seeing how GetChannelList() works..
							if a then ChatChannelList[a+4] = "|cff2E9AFE"..a..".|r  "..select(i*2,GetChannelList()) end
						end
						return ChatChannelList end,
					get = function(i) return char.chatChannel end,
					set = function(i, v) char.chatChannel = v end,
				},
			},
		},
		Advanced = {
			type = "group",
			name = "",
			handler = KCL,
			args = {
				groupColoring = {
					type = "group",
					order = 1,
					name = "|TInterface\\Icons\\INV_Misc_Gem_Variety_02:20:20:1:0:"..iconCropped.."|t  |cffFFFFFF"..COLORS.."|r",
					args = {
						colorTaunt = {
							type = "color",
							order = 1,
							name = "|TInterface\\Icons\\Spell_Nature_Reincarnation:20:20:1:0:"..iconCropped.."|t  "..GetSpellInfo(355),
							get = function(i) return unpack(profile.color.Taunt) end,
							set = function(info, r,g,b) profile.color.Taunt = {r, g, b} end,
						},
						colorInterrupt = {
							type = "color",
							order = 2,
							name = "|TInterface\\Icons\\Ability_Kick:20:20:1:0:"..iconCropped.."|t  "..INTERRUPT,
							get = function(i) return unpack(profile.color.Interrupt) end,
							set = function(info, r,g,b) profile.color.Interrupt = {r, g, b} end,
						},
						colorDispel = {
							type = "color",
							order = 3,
							name = "|TInterface\\Icons\\Spell_Holy_DispelMagic:20:20:1:0:"..iconCropped.."|t  "..GetSpellInfo(25808),
							get = function(i) return unpack(profile.color.Dispel) end,
							set = function(info, r,g,b) profile.color.Dispel = {r, g, b} end,
						},
						colorReflect = {
							type = "color",
							order = 4,
							name = "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:20:20:1:0:"..iconCropped.."|t  "..REFLECT,
							get = function(i) return unpack(profile.color.Reflect) end,
							set = function(info, r,g,b) profile.color.Reflect = {r, g, b} end,
						},
						colorCrowdControl = {
							type = "color",
							order = 5,
							name = "|TInterface\\Icons\\Spell_Nature_Polymorph:20:20:1:0:"..iconCropped.."|t  Crowd Control",
							get = function(i) return unpack(profile.color.CrowdControl) end,
							set = function(info, r,g,b) profile.color.CrowdControl = {r, g, b} end,
						},
						colorCC_Break = {
							type = "color",
							order = 6,
							name = "|TInterface\\Icons\\Ability_Seal:20:20:1:0:"..iconCropped.."|t  CC Breaker",
							get = function(i) return unpack(profile.color.CC_Break) end,
							set = function(info, r,g,b) profile.color.CC_Break = {r, g, b} end,
						},
						colorDeath = {
							type = "color",
							order = 7,
							name = "|TInterface\\Icons\\Ability_Rogue_FeignDeath:20:20:1:0:"..iconCropped.."|t  "..TUTORIAL_TITLE25,
							get = function(i) return unpack(profile.color.Death) end,
							set = function(info, r,g,b) profile.color.Death = {r, g, b} end,
						},
						colorResurrection = {
							type = "color",
							order = 8,
							name = "|TInterface\\Icons\\Spell_Holy_Resurrection:20:20:1:0:"..iconCropped.."|t  "..GetSpellInfo(2006),
							get = function(i) return unpack(profile.color.Resurrection) end,
							set = function(info, r,g,b) profile.color.Resurrection = {r, g, b} end,
						},
						spacing01 = {type = "description", order = 9, name = " "},
						colorPhysical = {
							type = "color",
							order = 10,
							name = "|TInterface\\Icons\\Spell_Nature_Strength:20:20:1:0:"..iconCropped.."|t  "..STRING_SCHOOL_PHYSICAL,
							get = function(i) return unpack(profile.color.Physical) end,
							set = function(info, r,g,b) profile.color.Physical = {r, g, b} end,
						},
						colorHoly = {
							type = "color",
							order = 11,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon2:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_HOLY,
							get = function(i) return unpack(profile.color.Holy) end,
							set = function(info, r,g,b) profile.color.HolySpell = {r, g, b} end,
						},
						colorFire = {
							type = "color",
							order = 12,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon3:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FIRE,
							get = function(i) return unpack(profile.color.Fire) end,
							set = function(info, r,g,b) profile.color.Fire = {r, g, b} end,
						},
						colorNature = {
							type = "color",
							order = 13,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon4:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_NATURE,
							get = function(i) return unpack(profile.color.Nature) end,
							set = function(info, r,g,b) profile.color.Nature = {r, g, b} end,
						},
						colorFrost = {
							type = "color",
							order = 14,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon5:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FROST,
							get = function(i) return unpack(profile.color.Frost) end,
							set = function(info, r,g,b) profile.color.Frost = {r, g, b} end,
						},
						colorShadow = {
							type = "color",
							order = 15,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon6:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_SHADOW,
							get = function(i) return unpack(profile.color.Shadow) end,
							set = function(info, r,g,b) profile.color.Shadow = {r, g, b} end,
						},
						colorArcane = {
							type = "color",
							order = 16,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon7:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_ARCANE,
							get = function(i) return unpack(profile.color.Arcane) end,
							set = function(info, r,g,b) profile.color.Arcane = {r, g, b} end,
						},
						spacing02 = {type = "description", order = 17, name = " "},
						colorDeathKnight = {
							type = "color",
							order = 18,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:133:189|t  Death Knight",
							get = function(i) return unpack(profile.color.DeathKnight) end,
							set = function(info, r,g,b) profile.color.DeathKnight = {r, g, b} end,
						},
						colorDruid = {
							type = "color",
							order = 19,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:194:250:4:60|t  Druid",
							get = function(i) return unpack(profile.color.Druid) end,
							set = function(info, r,g,b) profile.color.Druid = {r, g, b} end,
						},
						colorHunter = {
							type = "color",
							order = 20,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:68:124|t  Hunter",
							get = function(i) return unpack(profile.color.Hunter) end,
							set = function(info, r,g,b) profile.color.Hunter = {r, g, b} end,
						},
						colorMage = {
							type = "color",
							order = 21,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:4:60|t  Mage",
							get = function(i) return unpack(profile.color.Mage) end,
							set = function(info, r,g,b) profile.color.Mage = {r, g, b} end,
						},
						colorPaladin = {
							type = "color",
							order = 22,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:132:188|t  Paladin",
							get = function(i) return unpack(profile.color.Paladin) end,
							set = function(info, r,g,b) profile.color.Paladin = {r, g, b} end,
						},
						colorPriest = {
							type = "color",
							order = 23,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:130:186:68:124|t  Priest",
							get = function(i) return unpack(profile.color.Priest) end,
							set = function(info, r,g,b) profile.color.Priest = {r, g, b} end,
						},
						colorRogue = {
							type = "color",
							order = 24,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:131:187:4:60|t  Rogue",
							get = function(i) return unpack(profile.color.Rogue) end,
							set = function(info, r,g,b) profile.color.Rogue = {r, g, b} end,
						},
						colorShaman = {
							type = "color",
							order = 25,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:68:124|t  Shaman",
							get = function(i) return unpack(profile.color.Shaman) end,
							set = function(info, r,g,b) profile.color.Shaman = {r, g, b} end,
						},
						colorWarlock = {
							type = "color",
							order = 26,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:194:250:68:124|t  Warlock",
							get = function(i) return unpack(profile.color.Warlock) end,
							set = function(info, r,g,b) profile.color.Warlock = {r, g, b} end,
						},
						colorWarrior = {
							type = "color",
							order = 27,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:4:60|t  Warrior",
							get = function(i) return unpack(profile.color.Warrior) end,
							set = function(info, r,g,b) profile.color.Warrior = {r, g, b} end,
						},
						spacing03 = {type = "description", order = 28, name = " "},
						colorFriendly = {
							type = "color",
							order = 29,
							name = "|TInterface\\Icons\\Spell_ChargePositive:20:20:1:0:"..iconCropped.."|t  "..COMBATLOG_FILTER_STRING_FRIENDLY_UNITS,
							get = function(i) return unpack(profile.color.Friendly) end,
							set = function(info, r,g,b) profile.color.Friendly = {r, g, b} end,
						},
						colorHostile = {
							type = "color",
							order = 30,
							name = "|TInterface\\Icons\\Spell_ChargeNegative:20:20:1:0:"..iconCropped.."|t  "..COMBATLOG_FILTER_STRING_HOSTILE_UNITS,
							get = function(i) return unpack(profile.color.Hostile) end,
							set = function(info, r,g,b) profile.color.Hostile = {r, g, b} end,
						},
						colorUnknown = {
							type = "color",
							order = 31,
							name = "|TInterface\\Icons\\INV_Misc_QuestionMark:20:20:1:0:"..iconCropped.."|t  "..COMBATLOG_FILTER_STRING_UNKNOWN_UNITS,
							get = function(i) return unpack(profile.color.Unknown) end,
							set = function(info, r,g,b) profile.color.Unknown = {r, g, b} end,
						},
						spacing04 = {type = "description", order = 32, name = "\n"},
						executeReset = {
							type = "execute",
							order = 33,
							descStyle = "",
							name = "|TInterface\\Icons\\INV_Misc_Rune_01:20:20:1:0:"..iconCropped.."|t |cffFFFFFFReset Colors|r",
							confirm = true, confirmText = "Reset Colors?  |TInterface\\Icons\\INV_Misc_QuestionMark:22:22:1:0:"..iconCropped.."|t",
							func = function()
							--	for some weird reason the defaults also get saved/changed; hardcoding it it in again then..
							--	profile.color = KCL.db.defaults.profile.color
							--	profile.color = KethoCombatLogDB.profiles.Default.color -- lol, epic fail :(
								profile.color = {
									Taunt = {1, 0, 0},
									Interrupt = {0, 110/255, 1},
									Dispel = {1, 1, 1},
									Reflect = {1, 1, 1},
									CrowdControl = {1, 1, 1},
									CC_Break = {1, 1, 1},
									Death = {1, 1, 1},
									Resurrection = {175/255, 1, 47/255},
									Physical = {1.00, 1.00, 0.00},
									Holy = {1.00, 0.90, 0.50},
									Fire = {1.00, 0.50, 0.00},
									Nature = {0.30, 1.00, 0.30},
									Frost = {0.50, 1.00, 1.00},
									Shadow = {0.50, 0.50, 1.00},
									Arcane = {1.00, 0.50, 1.00},
									DeathKnight = {0.77, 0.12, 0.23},
									Druid = {1.00 , 0.49, 0.04},
									Hunter = {0.67, 0.83, 0.45},
									Mage = {0.41, 0.80, 0.94},
									Paladin = {0.96, 0.55, 0.73},
									Priest = {1.00, 1.00, 1.00},
									Rogue = {1.00, 0.96, 0.41},
									Shaman = {0.00, 0.44, 0.87},
									Warlock = {0.58, 0.51, 0.79},
									Warrior = {0.78, 0.61, 0.43},
									Friendly = {0.34, 0.64, 1.00},
									Hostile = {0.75, 0.05, 0.05},
									Unknown = {191/255, 191/255, 191/255},
								}
							end,
						},
					},
				},
				groupAdvanced = {
					type = "group",
					order = 2,
					name = "|TInterface\\Icons\\Trade_Engineering:20:20:1:0:"..iconCropped.."|t  |cffFFFFFF"..ADVANCED_LABEL.."|r",
					args = {
						selectIconSize = {
							type = "select",
							order = 1,
							descStyle = "", 
							name = STAT_CATEGORY_SPELL.." "..EMBLEM_SYMBOL.." |cffFFFFFFSize|r",
							values = {"|cffFF0000<"..ADDON_DISABLED..">|r", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, " 12", nil, " 14", nil, " 16  |cffFBDB00(Default)|r", nil, " 18",  nil, " 20", nil, " 22", nil, " 24", nil, " 26", nil, " 28", nil, " 30", nil, " 32"},
							get = function(i) return profile.iconSize end,
							set = function(i, v) profile.iconSize = v end,
						},
						toggleCropIcon = {
							type = "toggle",
							order = 2,
							descStyle = "",
							name = "|TInterface\\Icons\\Trade_Engineering:26:26:1:0|t |TInterface\\Icons\\Trade_Engineering:24:24:1:0:64:64:4:60:4:60|t  |cffADFF2FCrop|r "..STAT_CATEGORY_SPELL.." "..EMBLEM_SYMBOL.."",
							disabled = function() return not profile.iconSize or not profile.enableAddOn end,
							get = function(i) return profile.iconCropped end,
							set = function(i, v) profile.iconCropped = v; if v then iconCropped = "64:64:4:60:4:60" else iconCropped = "" end; end,
						},
						header1 = {type = "header", order = 3, name = ""},
						toggleTimestamp = {
							type = "toggle",
							order = 4,
							desc = TIMESTAMP_COMBATLOG_TOOLTIP,
							name = TIMESTAMPS_LABEL,
							get = function(i) return profile.Timestamp end,
							set = function(i, v) profile.Timestamp = v end,
						},
						header2 = {type = "header", order = 5, name = ""},
						toggleBlizzardCombatLog = {
							type = "toggle",
							order = 6,
							desc = BINDING_NAME_TOGGLECOMBATLOG,
							name = "Blizzard CombatLog",
							get = function(i) return profile.BlizzardCombatLog end,
							set = function(i, v) profile.BlizzardCombatLog = v
								if v then COMBATLOG:RegisterEvent("COMBAT_LOG_EVENT"); print("Blizzard CombatLog: |cffB6CA00Enabled|r")
								else COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT") print("Blizzard CombatLog: |cffFF2424Disabled|r")
								end
							end,
						},
						toggleChatLogging = {
							type = "toggle",
							order = 7,
							descStyle = "",
							name = CHAT.." Logging",
							get = function(i) return profile.ChatLogging end,
							set = function(i, v) profile.ChatLogging = v
								if v then 
									if not LoggingChat() then LoggingChat(true); print("|cffFFFF00"..CHATLOGENABLED.."|r")
									else print("|cffFFFF00Already Enabled Chat Logging|r") end
								else
									if LoggingChat() then LoggingChat(false); print("|cffFFFF00"..CHATLOGDISABLED.."|r")
									else print("|cffFFFF00Already Disabled Chat Logging|r") end
								end
							end,
						},
						toggleCombatLogging = {
							type = "toggle",
							order = 8,
							descStyle = "",
							name = COMBAT.." Logging",
							get = function(i) return profile.CombatLogging end,
							set = function(i, v) profile.CombatLogging = v
								if v then
									if not LoggingCombat() then LoggingCombat(true); print("|cffFFFF00"..COMBATLOGENABLED.."|r")
									else print("|cffFFFF00Already Enabled Combat Logging|r") end
								else
									if LoggingCombat() then LoggingCombat(false); print("|cffFFFF00"..COMBATLOGDISABLED.."|r")
									else print("|cffFFFF00Already Disabled Combat Logging|r") end
								end
							end,
						},
					},
				},
				groupFun = {
					type = "group",
					order = 3,
					name = "|TInterface\\AddOns\\Ketho_CombatLog\\Images\\Awesome:20:20:1:0|t  |cffF6ADC6Fun|r",
					args = {
						toggleFeast = {
							type = "toggle",
							order = 1,
							desc = "|cffF6ADC6\"om nom nom nom\"|r", 
							name = "  Feasts",
							get = function(i) return profile.Feast end,
							set = function(i, v) profile.Feast = v end,
						},
						descriptionFeasts = {
							type = "description",
							order = 2,
							name = "     |TInterface\\Icons\\Spell_Misc_Food:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Food_Meat_Cooked_02:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Food_99:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Fish_52:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\Ability_Hunter_Pet_Boar:32:32:0:0:"..iconCropped.."|t",
						},
						header2 = {type = "header", order = 3, name = ""},
						toggleRepairBot = {
							type = "toggle",
							order = 4,
							desc = "|cffF6ADC6\"oh god not another wipe\"|r", 
							name = "  Repair Bots",
							get = function(i) return profile.RepairBot end,
							set = function(i, v) profile.RepairBot = v end,
						},
						descriptionRepairBot = {
							type = "description",
							order = 5,
							name = "     |TInterface\\Minimap\\Tracking\\Repair:36:36:-2:0:"..iconCropped.."|t    |TInterface\\Icons\\inv_pet_lilsmoky:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_EngGizmos_14:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\inv_misc_molle:32:32:0:0:"..iconCropped.."|t",
						},
						header3 = {type = "header", order = 6, name = ""},
						toggleFun = {
							type = "toggle",
							order = 7,
							desc = "|cffF6ADC6\"trolololol\"|r", 
							name = "  \"Fun\"",
							get = function(i) return profile.Fun end,
							set = function(i, v) profile.Fun = v end,
						},
						descriptionFun = {
							type = "description",
							order = 8,
							name = "     |TInterface\\AddOns\\Ketho_CombatLog\\Images\\Awesome:32:32:0:0|t    |TInterface\\Icons\\inv_misc_mohawkgrenade:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Toy_10:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Bag_28_Halloween:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Sandbox_Spectraltiger_01:32:32:0:0:"..iconCropped.."|t",
						},
						header4 = {type = "header", order = 9, name = ""},
					},
				},
				groupAbility = {
					type = "group",
					order = 4,
					name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:20:20:1:0:"..iconCropped.."|t  |cffFFFFFF"..COMBATLOG_HIGHLIGHT_ABILITY.."|r",
					args = {
						toggleSoulstoneResurrection = {
							type = "toggle",
							order = 1,
							desc = "Stores the friendly target's soul.  If the target dies while his soul is stored, he will be able to resurrect with |cff71D5FF30%|r health and |cff71D5FF30%|r mana.", 
							name = "|TInterface\\Icons\\Spell_Shadow_SoulGem:24:24:1:0:"..iconCropped.."|t  |cff9482C9"..GetSpellInfo(20707).."|r",
							get = function(i) return profile.abilitySoulstone end,
							set = function(i, v) profile.abilitySoulstone = v end,
						},
						toggleFocusMagic = {
							type = "toggle",
							order = 2,
							desc = "Increases the target's chance to critically hit with spells by |cff71D5FF3%|r for |cff71D5FF30 min|r.  When the target critically hits your chance to critically hit with spells is increased by |cff71D5FF3%|r for |cff71D5FF10 sec|r.  Cannot be cast on self.  Limit 1 target.", 
							name = "|TInterface\\Icons\\Spell_Arcane_StudentOfMagic:24:24:1:0:"..iconCropped.."|t  |cff69CCF0"..GetSpellInfo(54646).."|r",
							get = function(i) return profile.abilityFocusMagic end,
							set = function(i, v) profile.abilityFocusMagic = v end,
						},
						toggleVigilance = {
							type = "toggle",
							order = 3,
							desc = "Focus your protective gaze on a group or raid target.  Each time they are hit by an attack your |cff71D5FFTaunt|r cooldown is refreshed and you gain |cff71D5FFVengeance|r as if |cff71D5FF20%|r of the damage was done to you.  Lasts |cff71D5FF30 min|r.  This effect can only be on one target at a time.", 
							name = "|TInterface\\Icons\\Ability_Warrior_Vigilance:24:24:1:0:"..iconCropped.."|t  |cffC79C6E"..GetSpellInfo(50720).."|r",
							get = function(i) return profile.abilityVigilance end,
							set = function(i, v) profile.abilityVigilance = v end,
						},
						toggleMisdirection = {
							type = "toggle",
							order = 4,
							desc = "The current party or raid member targeted will receive the threat caused by your next damaging attack and all actions taken for |cff71D5FF4 sec|r afterwards.  Transferred threat is not permanent, and will fade after |cff71D5FF30 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Hunter_Misdirection:24:24:1:0:"..iconCropped.."|t  |cffABD473"..GetSpellInfo(34477).."|r",
							get = function(i) return profile.abilityMisdirection end,
							set = function(i, v) profile.abilityMisdirection = v end,
						},
						toggleTricksTrade = {
							type = "toggle",
							order = 5,
							desc = "The threat caused by your next damaging attack and all actions taken for |cff71D5FF6 sec|r afterwards will be transferred to the target party or raid member, and all damage caused by the target is increased by |cff71D5FF15%|r during this time.  Transferred threat is not permanent, and will fade after |cff71D5FF30 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:24:24:1:0:"..iconCropped.."|t  |cffFFF569"..GetSpellInfo(57934).."|r",
							get = function(i) return profile.abilityTricksTrade end,
							set = function(i, v) profile.abilityTricksTrade = v end,
						},
						toggleInnervate = {
							type = "toggle",
							order = 6,
							desc = "Causes the target to regenerate mana equal to |cff71D5FF20%|r of the casting |cffFF7D0ADruid's|r maximum mana pool over |cff71D5FF10 sec|r.", 
							name = "|TInterface\\Icons\\Spell_Nature_Lightning:24:24:1:0:"..iconCropped.."|t  |cffFF7D0A"..GetSpellInfo(29166).."|r",
							get = function(i) return profile.abilityInnervate end,
							set = function(i, v) profile.abilityInnervate = v end,
						},
						toggleHeroismBloodlust = {
							type = "toggle",
							order = 7,
							desc = "Increases melee, ranged, and spell casting speed by |cff71D5FF30%|r for all party and raid members.  Lasts |cff71D5FF40 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Shaman_Heroism:24:24:1:0:"..iconCropped.."|t |TInterface\\Icons\\Spell_Nature_BloodLust:24:24:1:0:"..iconCropped.."|t  |cff0070DE"..GetSpellInfo(32182).."|r / |cff0070DE"..GetSpellInfo(2825).."|r",
							get = function(i) return profile.abilityBloodlust end,
							set = function(i, v) profile.abilityBloodlust = v end,
						},
						toggleRitualRefreshment = {
							type = "toggle",
							order = 8,
							desc = "Begins a ritual that creates a refreshment table.  Raid members can click the table to acquire Conjured mana food.  The tables lasts for |cff71D5FF3 min|r or |cff71D5FF50 charges|r.  Requires the caster and 2 additional party members to complete the ritual.  In order to participate, all players must right-click the refreshment portal and not move until the ritual is complete.", 
							name = "|TInterface\\Icons\\Spell_Arcane_MassDispel:24:24:1:0:"..iconCropped.."|t  |cff69CCF0"..GetSpellInfo(43987).."|r",
							get = function(i) return profile.abilityRitualRefreshment end,
							set = function(i, v) profile.abilityRitualRefreshment = v end,
						},
						toggleFearWard = {
							type = "toggle",
							order = 9,
							desc = "Wards the friendly target against |cff71D5FFFear|r.  The next Fear effect used against the target will fail, using up the ward.  Lasts |cff71D5FF3 min|r.", 
							name = "|TInterface\\Icons\\Spell_Holy_Excorcism:24:24:1:0:"..iconCropped.."|t  "..GetSpellInfo(6346).."",
							get = function(i) return profile.abilityFearWard end,
							set = function(i, v) profile.abilityFearWard = v end,
						},
						toggleMindVision = {
							type = "toggle",
							order = 10,
							desc = "Allows the caster to see through the target's eyes for |cff71D5FF1 min|r.  Will not work if the target is in another instance or on another continent.", 
							name = "|TInterface\\Icons\\Spell_Holy_MindVision:24:24:1:0:"..iconCropped.."|t  "..GetSpellInfo(2096).."",
							get = function(i) return profile.abilityMindVision end,
							set = function(i, v) profile.abilityMindVision = v end,
						},
						header = {type = "header", order = 11, name = ""},
						toggleExcludeSelf = {
							type = "toggle",
							order = 12,
							descStyle = "",
							name = "Exclude yourself",
							get = function(i) return profile.abilityExcludeSelf end,
							set = function(i, v) profile.abilityExcludeSelf = v end,
						},

					},
				},
				groupAbout = {
					type = "group",
					order = 5,
					name = "|TInterface\\Icons\\INV_Misc_QuestionMark:20:20:1:0:"..iconCropped.."|t  |cffFFFFFFAbout|r",
					args = {
						header1 = {
							type = "header",
							order = 1,
							name = "Changelog |cffADFF2Fv0.94|r",
						},
						description1 = {
							type = "description",
							order = 2,
							name = "- Hotfixed for Patch |cffB6CA004.1.0|r\n- Updated Crowd Control: |cff9482C9[Fear]|r, |cff0070DE[Bind Elemental]|r\n- Fixed |cffABD473[Misdirection]|r & |cffFFF569[Tricks of the Trade]|r\n",
						},
						header2 = {
							type = "header",
							order = 3,
							name = "To Do",
						},
						description2 = {
							type = "description",
							order = 4,
							name = "- Code Optimization\n- Locales\n-\"Scrolling Combat Text\" support\n",
						},
						header3 = {
							type = "header",
							order = 5,
							name = "Known Bugs",
						},
						description3 = {
							type = "description",
							order = 6,
							name = "1) \"False positive Deaths\"\n2) |cff71D5FFDuel Losses|r show as deaths\n\n",
						},
						description4 = {
							type = "description",
							order = 7,
							name = function() local a, b = UnitFactionGroup("player")
								if a == "Alliance" then b = "War3_MountainKing"
								elseif a == "Horde" then b = "War3_Blademaster" end
							return "|TInterface\\AddOns\\Ketho_CombatLog\\Images\\"..b..":64:64:2:0|t" end,
						},
					},
				},
			},
		},
	},
}

	----------------------------------------------
	---- 03  OnInitialize, OnEnable, OnDisable ---
	----------------------------------------------

function KCL:OnInitialize()

	-- http://www.wowace.com/addons/ace3/pages/api/ace-db-3-0/
	self.db = LibStub("AceDB-3.0"):New("KethoCombatLogDB", defaults, true) -- KethoCombatLog.db
	
	-- not sure anymore if table reference shortcuts can be mixed with the AceDB magic ...
	-- http://old.wowace.com/wiki/Coding_Tips#Cost_of_table_lookup
	profile, char, color = self.db.profile, self.db.char, self.db.profile.color
	
	self.db.RegisterCallback(self, "OnProfileChanged", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	self.db.RegisterCallback(self, "OnProfileReset", "RefreshConfig")

	self.db.global.version = 0.94
	self.db.global.fileType = "Release"

	-- http://www.wowace.com/addons/ace3/pages/api/ace-config-registry-3-0/
	-- http://www.wowace.com/addons/ace3/pages/api/ace-dboptions-3-0/
	ACR:RegisterOptionsTable("KethoCombatLog_Main", options.args.Main)
	ACR:RegisterOptionsTable("KethoCombatLog_Advanced", options.args.Advanced)
	ACR:RegisterOptionsTable("KethoCombatLog_Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db))

	-- http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/	
	local Main = "Ketho |cffFFFFFFCombatLog|r|TInterface\\Icons\\INV_Sword_01:20:20:8:0:"..iconCropped.."|t"
	self.optionsFrame = ACD:AddToBlizOptions("KethoCombatLog_Main", Main) -- "self.optionsFrame" used for "InterfaceOptionsFrame_OpenToCategory"
	ACD:AddToBlizOptions("KethoCombatLog_Advanced", "|TInterface\\Icons\\Trade_Engineering:24:24:1:0:"..iconCropped.."|t  "..ADVANCED_LABEL, Main)
	ACD:AddToBlizOptions("KethoCombatLog_Profiles", "|TInterface\\Icons\\INV_Misc_Note_01:24:24:1:0:"..iconCropped.."|t  Profiles", Main)

	-- http://www.wowace.com/addons/ace3/pages/api/ace-console-3-0/
	self:RegisterChatCommand("kcl", "SlashCommand")
	self:RegisterChatCommand("ket", "SlashCommand")
	self:RegisterChatCommand("ketho", "SlashCommand")
	self:RegisterChatCommand("kethocombat", "SlashCommand")
	self:RegisterChatCommand("kethocombatlog", "SlashCommand")
	
--	Initialize upvalued stuff from the AceDB / AddOn API
	playerColor = KCL_UnitLinkClass("player", nil, player.Class)
	if char.chatWindow > 1 then CF = _G["ChatFrame"..char.chatWindow-1] end
	if profile.ChatLogging then LoggingChat(true) end -- however, dont disable if false, so it wont interfere with other addons
	if profile.CombatLogging then LoggingCombat(true) end
	if profile.iconCropped then iconCropped = "64:64:4:60:4:60" else iconCropped = "" end

	if not profile.enableAddOn then
		self:Disable() -- Turn AddOn off again
	end
end

function KCL:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("ADDON_LOADED") -- Check for Blizzard CombatLog
end

function KCL:OnDisable()
	self:UnregisterAllEvents()
end

	------------------------------
	--- 04  Callback Functions ---
	------------------------------

-- AceDB profile changes destroy my table reference lookup shortcuts :(
function KCL:RefreshConfig()
	profile, char, color = self.db.profile, self.db.char, self.db.profile.color
	
	-- quick n dirty fix for enableAddOn button
	-- not sure if it even works
	if self:IsEnabled() then
		profile.enableAddOn = true
		self:Enable()
	else
		profile.enableAddOn = false
		self:Disable()
	end
end

-- gray out options when AddOn disabled
function KCL:OptionsDisabled()
	return not self:IsEnabled()
end

function KCL:SlashCommand(input)
	if not input or strtrim(input) == "" then
		InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)

	elseif input == "on" then
		if not profile.enableAddOn then self:Enable(); profile.enableAddOn = true; self:Print("|cffB6CA00Enabled|r")
		else self:Print("Already |cffB6CA00Enabled|r") end LibStub("AceConfigRegistry-3.0"):NotifyChange("KethoCombatLog_Main")

	elseif input == "off" then
		if profile.enableAddOn then self:Disable(); profile.enableAddOn = false; self:Print("|cffFF2424Disabled|r")
		else self:Print("Already |cffFF2424Disabled|r") end LibStub("AceConfigRegistry-3.0"):NotifyChange("KethoCombatLog_Main")

	elseif input == "silence" then -- AceTimer here is only for feedback purpose
		if timeSilence == 0 then self:Print("Silenced: 1 Minute")
		else self:Print("Refreshed Silence: 1 Minute"); self:CancelTimer(self.silenceTimer, true) end
		timeSilence = GetTime() + 60; self.silenceTimer = self:ScheduleTimer(function() timeSilence = 0; self:Print("Unsilenced") end, 60)

	elseif input == "unsilence" then
		if timeSilence > 0 then self:Print("Unsilenced")
		else self:Print("Already Unsilenced") end
		timeSilence = 0; self:CancelTimer(self.silenceTimer, true) -- check if it silently fails if no AceTimer handle

	else
		local a, b, c = "|cff2E9AFE", "|cffB6CA00", "|cffFF2424"
		print(a.."/ket|r: Opens Options\n"..a.."/ket|r "..b.."on|r: Turns AddOn on\n"..a.."/ket|r "..c.."off|r: Turns AddOn off\n"..a.."/ket|r "..c.."silence|r: Stops announce for |cff71D5FF60 sec.|r\n"..a.."/ket|r "..b.."un|r"..c.."silence|r: Resumes announce")
	end
end

function KCL_Dec2Hex(R, G, B) -- http://www.wowpedia.org/RGBToHex
	return string.format("%02X%02X%02X", R*255, G*255, B*255)
end

function KCL_checkTable(spellID, someTable)
	for _, v in pairs(someTable) do
		if v == spellID then
			return true
		end
	end
end

-- Class Color, Unit Link
function KCL_UnitLinkClass(info, unitID, unitClass, unitGUID, sourceName, destName) -- http://www.wowpedia.org/Class_colors
	local classColor, name
	if	   unitClass == "DEATHKNIGHT" then classColor = KCL_Dec2Hex(unpack(color.DeathKnight))
	elseif unitClass == "DRUID"		  then classColor = KCL_Dec2Hex(unpack(color.Druid))
	elseif unitClass == "HUNTER"	  then classColor = KCL_Dec2Hex(unpack(color.Hunter))
	elseif unitClass == "MAGE"		  then classColor = KCL_Dec2Hex(unpack(color.Mage))
	elseif unitClass == "PALADIN"	  then classColor = KCL_Dec2Hex(unpack(color.Paladin))
	elseif unitClass == "PRIEST"	  then classColor = KCL_Dec2Hex(unpack(color.Priest))
	elseif unitClass == "ROGUE"		  then classColor = KCL_Dec2Hex(unpack(color.Rogue))
	elseif unitClass == "SHAMAN"	  then classColor = KCL_Dec2Hex(unpack(color.Shaman))
	elseif unitClass == "WARLOCK"	  then classColor = KCL_Dec2Hex(unpack(color.Warlock))
	elseif unitClass == "WARRIOR"	  then classColor = KCL_Dec2Hex(unpack(color.Warrior))
	end
	if unitID == "group" and destName then name = UnitName(destName)
	elseif unitID == "group" and not destName then name = UnitName(sourceName)
	elseif unitID == "target" then name = UnitName("target")
	end
	if info == "source" then
		return name, "|cff"..classColor.."|Hunit:"..unitGUID..":"..name.."|h["..name.."]|h|r"
	elseif info == "dest" then local a
		if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = name end
		return name, "|cff"..classColor.."|Hunit:"..unitGUID..":"..name.."|h["..a.."]|h|r"
	elseif info == "player" then
		return classColor
	end
end

-- Spell School (Colored), Extra Spell School (Colored)
function KCL_spellSchool(value)
	local a, b
	if	   value == 0x1  then a = STRING_SCHOOL_PHYSICAL; b = KCL_Dec2Hex(unpack(color.Physical))
	elseif value == 0x2  then a = STRING_SCHOOL_HOLY;	  b = KCL_Dec2Hex(unpack(color.Holy))
	elseif value == 0x4  then a = STRING_SCHOOL_FIRE;	  b = KCL_Dec2Hex(unpack(color.Fire))
	elseif value == 0x8  then a = STRING_SCHOOL_NATURE;	  b = KCL_Dec2Hex(unpack(color.Nature))
	elseif value == 0x10 then a = STRING_SCHOOL_FROST;	  b = KCL_Dec2Hex(unpack(color.Frost))
	elseif value == 0x20 then a = STRING_SCHOOL_SHADOW;	  b = KCL_Dec2Hex(unpack(color.Shadow))
	elseif value == 0x40 then a = STRING_SCHOOL_ARCANE;	  b = KCL_Dec2Hex(unpack(color.Arcane))
--	Double schools
	elseif value == 0x3  then a = STRING_SCHOOL_HOLYSTRIKE
	elseif value == 0x5  then a = STRING_SCHOOL_FLAMESTRIKE
	elseif value == 0x6  then a = STRING_SCHOOL_HOLYFIRE
	elseif value == 0x9  then a = STRING_SCHOOL_STORMSTRIKE
	elseif value == 0xA  then a = STRING_SCHOOL_HOLYSTORM
	elseif value == 0xC  then a = STRING_SCHOOL_FIRESTORM
	elseif value == 0x11 then a = STRING_SCHOOL_FROSTSTRIKE
	elseif value == 0x12 then a = STRING_SCHOOL_HOLYFROST
	elseif value == 0x14 then a = STRING_SCHOOL_FROSTFIRE
	elseif value == 0x18 then a = STRING_SCHOOL_FROSTSTORM
	elseif value == 0x21 then a = STRING_SCHOOL_SHADOWSTRIKE
	elseif value == 0x22 then a = STRING_SCHOOL_SHADOWLIGHT
	elseif value == 0x24 then a = STRING_SCHOOL_SHADOWFLAME
	elseif value == 0x28 then a = STRING_SCHOOL_SHADOWSTORM
	elseif value == 0x30 then a = STRING_SCHOOL_SHADOWFROST
	elseif value == 0x41 then a = STRING_SCHOOL_SPELLSTRIKE
	elseif value == 0x42 then a = STRING_SCHOOL_DIVINE
	elseif value == 0x44 then a = STRING_SCHOOL_SPELLFIRE			
	elseif value == 0x48 then a = STRING_SCHOOL_SPELLSTORM
	elseif value == 0x50 then a = STRING_SCHOOL_SPELLFROST
	elseif value == 0x60 then a = STRING_SCHOOL_SPELLSHADOW
--	Three or more schools
	elseif value == 0x1C then a = STRING_SCHOOL_ELEMENTAL
	elseif value == 0x7C then a = STRING_SCHOOL_CHROMATIC
	elseif value == 0x7E then a = STRING_SCHOOL_MAGIC
	elseif value == 0x7F then a = STRING_SCHOOL_CHAOS
	else a = STRING_SCHOOL_UNKNOWN.." ("..value..")"
	end
	if not b then b = "71D5FF" end
	return a, b, "|cff"..b..a.."|r" -- school(Name)(Color), extraSchool(Name)(Color)
end

-- this part could see some improvement on that bit.band for-loop
-- Unit Reaction (Colored), Raid Target Icon
function KCL_UnitFlags(info, Flags)
	if info == "reaction" then
		if band(Flags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 then return KCL_Dec2Hex(unpack(color.Friendly)) -- Friendly Reaction Color
		elseif band(Flags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then return KCL_Dec2Hex(unpack(color.Hostile)) -- Hostile Reaction Color
		else return KCL_Dec2Hex(unpack(color.Unknown)) -- Unknown Reaction Color
		end
	elseif info == "raidtarget" then
		local a, b = "", ""
		for i = 1, 8 do
			if band(Flags, _G["COMBATLOG_OBJECT_RAIDTARGET"..i]) > 0 then -- .. does this defeat the purpose of making globals upvalues?
				a = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..i..":"..profile.iconSize.."|t" -- Raid Target Icon
				b = "{rt"..i.."}"
			end
		end
		return a, b
	end
end

	-----------------------------
	--- 05  OnEvent Functions ---
	-----------------------------

function KCL:ADDON_LOADED(event, addon) -- Blizzard CombatLog is Load-on-Demand and dont wanna load it before Ketho CombatLog, just to "disable" it again
	if addon == "Blizzard_CombatLog" and not profile.BlizzardCombatLog then
		COMBATLOG:UnregisterEvent("COMBAT_LOG_EVENT") -- disable Blizzard CombatLog
		self:UnregisterEvent("ADDON_LOADED") -- no need to register for "ADDON_LOADED" anymore
	end
end

-- omg. now I look back at this code .. it looks so freaking ugly and inefficient
function KCL:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)

	-- patch 4.1.0 forwards compatible fix; perform a tail call
	if type(sourceGUID) == "boolean" then
		return self:COMBAT_LOG_EVENT_UNFILTERED(_, _, event, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	end

	local spellID, spellName, spellSchool, SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, _, SuffixParam6, SuffixParam7, _, SuffixParam9 = ...
	local Time = GetTime()

--	Refresh instanceType & announceType every 10 sec
	if Time > cd.instanceType then
		cd.instanceType = Time + 10; _, instanceType = IsInInstance()
		if instanceType == "party" or instanceType == "arena" then announceType = "PARTY"
		elseif instanceType == "raid" then announceType = "RAID"
		end
	end
--	InstanceType check (so the "workload" is optionally)
	if ((instanceType == "party" or instanceType == "raid") and profile.PvE) or
	((instanceType == "pvp" or instanceType == "arena") and profile.PvP) or
	(instanceType == "none" and profile.World) then

	---- Initialization ----
	--	Unit Type, Unit Reaction Coloring -- http://www.wowpedia.org/API_UnitGUID
		local sourceType = tonumber(strsub(sourceGUID, 5, 5)) -- 5th digit, string converted to number (decimal)
		local destType = tonumber(strsub(destGUID, 5, 5))
		local sourceReactionColor = KCL_UnitFlags("reaction", sourceFlags) -- http://www.wowpedia.org/UnitFlag
		local destReactionColor = KCL_UnitFlags("reaction", destFlags)
		local sourceRT, sourceRT2 = KCL_UnitFlags("raidtarget", sourceFlags) 
		local destRT, destRT2 = KCL_UnitFlags("raidtarget", destFlags) 
		local sourceLink, destLink, spellIcon, extraSpellIcon
		local schoolName, schoolColor, schoolNameColor
		local extraSchoolName, extraSchoolColor, extraSchoolNameColor
		
		if SuffixParam7 then SuffixParam7 = " "..TEXT_MODE_A_STRING_RESULT_CRITICAL else SuffixParam7 = "" end -- critical; reuse local variable instead of making new local variable
		if SuffixParam9 then SuffixParam9 = " "..TEXT_MODE_A_STRING_RESULT_CRUSHING else SuffixParam9 = "" end -- crushing
		local isTank = (UnitGroupRolesAssigned(sourceName) == "TANK")
		local datestamp1, datestamp2 if profile.Timestamp then datestamp2 = date("[%H:%M:%S] "); datestamp1 = "|cffA9A9A9"..datestamp2.."|r" else datestamp1, datestamp2 = "", "" end
		local sourceName2, destName2 -- call UnitName() whenever possible to remove (cross)realm names
		local a, b, q, r -- function-local scope, dynamic [upvalues / external local variables]

		local chatWindow, chatChannel = char.chatWindow, char.chatChannel
		if chatChannel == 2 then q = "SAY"
		elseif chatChannel == 3 then q = "YELL"
		elseif chatChannel == 4 then q = announceType
		else q = "CHANNEL"; r = chatChannel-4
		end

	--	Unit Link -- http://www.wowpedia.org/UI_escape_sequences
		if sourceName then
			if sourceName == player.Name then sourceLink = "|cff"..playerColor.."|Hunit:"..sourceGUID..":"..sourceName.."|h["..YOU.."]|h|r" -- You
			elseif UnitInParty(sourceName) or UnitInRaid(sourceName) then sourceName2, sourceLink = KCL_UnitLinkClass("source", "group", select(2,UnitClass(sourceName)), sourceGUID, sourceName) -- Party/Raid Class Color
			elseif sourceType == 0 and sourceName == UnitName("target") then sourceName2, sourceLink = KCL_UnitLinkClass("source", "target", select(2,UnitClass("target")), sourceGUID, sourceName) -- Target Class Color
			else sourceLink = "|cff"..sourceReactionColor.."|Hunit:"..sourceGUID..":"..sourceName.."|h["..sourceName.."]|h|r"
			end
			if not sourceName2 then sourceName2 = sourceName end -- fall back to sourceName if unit not in party/raid (for cutting out cross-realm names)
		end
		if destName then
			if destName == player.Name then
				if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = YOU end
				destLink = "|cff"..playerColor.."|Hunit:"..destGUID..":"..destName.."|h["..a.."]|h|r"
			elseif UnitInParty(destName) or UnitInRaid(destName) then destName2, destLink = KCL_UnitLinkClass("dest", "group", select(2,UnitClass(destName)), destGUID, sourceName, destName)
			elseif destType == 0 and destName == UnitName("target") then destName2, destLink = KCL_UnitLinkClass("dest", "target", select(2,UnitClass("target")), destGUID, sourceName, destName)
			else
				if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = destName end
				destLink = "|cff"..destReactionColor.."|Hunit:"..destGUID..":"..destName.."|h["..a.."]|h|r"
			end
			if destName == sourceName then destName2 = QUICKBUTTON_NAME_SELF end
			if not destName2 then destName2 = destName end -- fall back to destName if cant get valid UnitId
		end

		if event ~= "SWING_DAMAGE" and event ~= "SWING_MISSED" and event ~= "UNIT_DIED" and event ~= "PARTY_KILL" and event ~= "UNIT_DESTROYED" and event ~= "UNIT_DISSIPATES" then
		--	Spell School (Colored)
			if spellSchool then schoolName, schoolColor, schoolNameColor = KCL_spellSchool(spellSchool) end
		--	Spell Link + Colored
			spellLink = "|cff71d5ff|Hspell:"..spellID.."|h["..spellName.."]|h|r"
			spellLinkColor = "|cff"..schoolColor.."|Hspell:"..spellID.."|h["..spellName.."]|h|r"
		--	Spell Icon
			if select(3, GetSpellInfo(spellID)) and profile.iconSize > 1 then
				spellIcon = "|T"..select(3,GetSpellInfo(spellID))..":"..profile.iconSize..":"..profile.iconSize..":1:0:"..iconCropped.."|t"
			else spellIcon = ""
			end
			if event == "SPELL_INTERRUPT" or event == "SPELL_DISPEL" or event == "SPELL_DISPEL_FAILED" or event == "SPELL_STOLEN" or event == "SPELL_AURA_BROKEN_SPELL" then
				if SuffixParam3 then extraSchoolName, extraSchoolColor, extraSchoolNameColor = KCL_spellSchool(SuffixParam3) end
				extraSpellLink = "|cff71d5ff|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r"
				extraSpellLinkColor = "|cff"..extraSchoolColor.."|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r"
				if select(3, GetSpellInfo(SuffixParam1)) and profile.iconSize > 1 then
					extraSpellIcon = "|T"..select(3,GetSpellInfo(SuffixParam1))..":"..profile.iconSize..":"..profile.iconSize..":1:0:"..iconCropped.."|t"
				else extraSpellIcon = ""
				end
			end
		end
	---- Combat Events ----
	--	Deaths
		if profile.Death and destType == 0 and (Time > cd.Death or destName ~= lastDeath) then cd.Death = Time + 1 -- make sure dont show more than 1 killing blow on same person
			if (event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE") and SuffixParam2 > 0 then lastDeath = destName
				if not sourceLink then sourceLink = "" end -- no sourceName
				if sourceName2 then a = "["..sourceName2.."]" else a = "" end
				if destName == player.Name then b = " "..format(TEXT_MODE_A_STRING_RESULT_OVERKILLING, SuffixParam2) else b = "" end -- show overkill if the player died
				if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..KCL_Dec2Hex(unpack(color.Death))..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink..spellLinkColor..spellIcon.." "..SuffixParam1.." "..schoolNameColor..b..SuffixParam7..SuffixParam9) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_UNIT_DIED.." "..sourceRT2..a..spellLink.." "..SuffixParam1.." "..schoolName..SuffixParam7..SuffixParam9, q, nil, r) end
		--	"SWING_DAMAGE" event uses a different arguments system (spellID, spellName, spellSchool are "skipped")
			elseif event == "SWING_DAMAGE" and spellName > 0 then
				lastDeath = destName
				if SuffixParam4 then SuffixParam4 = " "..TEXT_MODE_A_STRING_RESULT_CRITICAL else SuffixParam4 = "" end -- critical; reuse local variable instead of making new local variable
				if SuffixParam6 then SuffixParam6 = " "..TEXT_MODE_A_STRING_RESULT_CRUSHING else SuffixParam6 = "" end -- crushing
				if destName == player.Name then b = " "..format(TEXT_MODE_A_STRING_RESULT_OVERKILLING, spellName) else b = "" end
				if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..KCL_Dec2Hex(unpack(color.Death))..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink.." "..spellID.." |cff"..KCL_Dec2Hex(unpack(color.Physical))..ACTION_SWING.."|r"..b..SuffixParam4..SuffixParam6) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_UNIT_DIED.." "..sourceRT2.."["..sourceName2.."] "..spellID.." "..ACTION_SWING..SuffixParam4..SuffixParam6, q, nil, r) end
		--	Death Prevents
			elseif event == "SPELL_HEAL" and (spellID == 48153 or spellID == 66235) then -- Priest [Guardian Spirit]48153(SPELL_HEAL) Paladin [Ardent Defender] 66235(SPELL_HEAL)
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor.." |cff"..KCL_Dec2Hex(unpack(color.Resurrection)).."prevented "..TUTORIAL_TITLE25.."|r "..destRT..destLink.." "..SuffixParam1.." "..schoolNameColor) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." prevented "..TUTORIAL_TITLE25.." "..destRT2.."["..destName2.."]"..spellLink.." "..SuffixParam1.." "..schoolName, q, nil, r) end
		--	Instagibs
			elseif event == "SPELL_INSTAKILL" then
				if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..KCL_Dec2Hex(unpack(color.Death))..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink..spellLinkColor..spellIcon) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_UNIT_DIED.." "..sourceRT2.."["..sourceName2.."]"..spellLink, q, nil, r) end
			end
		end
	--	Taunts
		if profile.Taunt and ((instanceType ~= "party" and instanceType ~= "raid") or profile.TankTaunt or (not profile.TankTaunt and not isTank)) then -- 1) not in instance/raid group; 2) in instance/raid group and option is on; 3) in instance party and source is not tank
			if (destType == 3 or destType == 4) and KCL_checkTable(spellID, Taunt) then
				if event == "SPELL_AURA_APPLIED" then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..KCL_Dec2Hex(unpack(color.Taunt)).."taunted|r "..destRT..destLink) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." taunted "..destRT2.."["..destName2.."]", q, nil, r) end
			--	Taunt Missed
				elseif event == "SPELL_MISSED" and (SuffixParam1 == "MISS" or SuffixParam1 == "RESIST" or SuffixParam1 == "IMMUNE") then
					if SuffixParam1 == "MISS" then SuffixParam1 = ACTION_SPELL_MISSED_MISS
					elseif SuffixParam1 == "RESIST" then SuffixParam1 = COMBAT_TEXT_RESIST
					elseif SuffixParam1 == "IMMUNE" then SuffixParam1 = ACTION_SPELL_MISSED_IMMUNE
					end
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." on "..destRT..destLink.." |cffFF7800"..ACTION_SPELL_CAST_FAILED.."|r ("..SuffixParam1..")") end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.."  on "..destRT2.."["..destName2.."] "..ACTION_SPELL_CAST_FAILED.." ("..SuffixParam1..")", q, nil, r) end
				end
			elseif event == "SPELL_CAST_SUCCESS" then
			--	AoE Taunt: Warrior 1161[Challenging Shout], Druid 5209[Challenging Roar]
				if spellID == 1161 or spellID == 5209 then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." AoE "..GetSpellInfo(355), unpack(profile.color.Taunt)) end -- some variation in the coloring method :)
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." AoE "..GetSpellInfo(355), q, nil, r) end
			--	Pet Growl: Hunter Pet 2649[Growl], Warlock Voidwalker 3716[Torment]
				elseif profile.PetGrowl and (destType == 3 or destType == 4) and (spellID == 2649 or spellID == 3716) then -- 
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." growled "..destRT..destLink) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." growled "..destRT2.."["..destName2.."]", q, nil, r) end
				end
			end
		end
	--	Interrupts
		if event == "SPELL_INTERRUPT" and profile.Interrupt then
			if not sourceLink then sourceLink = "" end
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..KCL_Dec2Hex(unpack(color.Interrupt))..ACTION_SPELL_INTERRUPT.."|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." "..ACTION_SPELL_INTERRUPT.." "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Dispels
		elseif event == "SPELL_DISPEL" and profile.Dispel then
			if (band(sourceFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 and band(destFlags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0) or (band(sourceFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 and band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0) then a = ACTION_SPELL_DISPEL_DEBUFF else a = ACTION_SPELL_DISPEL_BUFF end
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..KCL_Dec2Hex(unpack(color.Dispel))..a.."|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." "..a.." "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Spellsteals
		elseif event == "SPELL_STOLEN" and profile.Dispel then
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..KCL_Dec2Hex(unpack(color.Dispel))..ACTION_SPELL_STOLEN.."|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." "..ACTION_SPELL_STOLEN.." "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Reflects
		elseif event == "SPELL_MISSED" and profile.Reflect and SuffixParam1 == "REFLECT" then
			if not sourceLink then sourceLink = "" end
			if chatWindow>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..KCL_Dec2Hex(unpack(color.Reflect))..ACTION_SPELL_MISSED_REFLECT.."|r "..sourceRT..sourceLink..spellLinkColor..spellIcon) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_SPELL_MISSED_REFLECT.." "..sourceRT2.."["..sourceName2.."]"..spellLink, q, nil, r) end
	--	Resurrections
		elseif event == "SPELL_RESURRECT" and profile.Resurrection then
			if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..KCL_Dec2Hex(unpack(color.Resurrection))..ACTION_SPELL_RESURRECT.."|r "..destRT..destLink) end
			if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." "..ACTION_SPELL_RESURRECT.." "..destRT2.."["..destName2.."]", q, nil, r) end
	--	Crowd Control
		elseif event == "SPELL_AURA_APPLIED" and profile.CrowdControl then
			if KCL_checkTable(spellID, CrowdControl) then
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..KCL_Dec2Hex(unpack(color.CrowdControl)).."CC'ed|r "..destRT..destLink) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." CC'ed "..destRT2.."["..destName2.."]", q, nil, r) end
			end
	--	CC Breaker
		elseif profile.CC_Break and ((instanceType ~= "party" and instanceType ~= "raid") or profile.TankBreak or (not profile.TankBreak and not isTank)) then
			if event == "SPELL_AURA_BROKEN_SPELL" then -- broken by a spell
				if not sourceLink then sourceLink = "" end
				if sourceName2 then a = "["..sourceName2.."]" else a = "" end
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..extraSpellLinkColor..extraSpellIcon.." |cff"..KCL_Dec2Hex(unpack(color.CC_Break)).."broke|r "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2..a..extraSpellLink.." broke "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
			elseif event == "SPELL_AURA_BROKEN" then -- not broken by a spell; 4.0.1 bug? this event does not fire for CLEU
				if sourceName then
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." |cff"..KCL_Dec2Hex(unpack(color.CC_Break)).."broke|r "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]".." broke "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
				else
					if chatWindow>1 then CF:AddMessage(datestamp1..spellLinkColor..spellIcon.." on "..destRT..destLink.." |cff"..KCL_Dec2Hex(unpack(color.CC_Break)).."broken|r") end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..spellLink.." on "..destRT2.."["..destName2.."] broken", q, nil, r) end
				end
			end
		end
	--	Feast, Repair Bot, Fun
		if profile.Feast then
			if event == "SPELL_CREATE" and
			(spellID == 87644 or -- [Seafood Magnifique Feast]
			spellID == 87643 or -- [Broiled Dragon Feast]
			spellID == 87915 or -- [Goblin Barbecue Feast]
			spellID == 57426 or -- [Fish Feast]
			spellID == 57301 or -- [Great Feast]
			spellID == 56245 or -- [Chocolate Celebration Cake]
			spellID == 57301) then -- [Lovely Cake]
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then SCM("["..sourceName2.."] prepared a "..spellLink, "BATTLEGROUND")
				else
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." prepared a "..spellLinkColor..spellIcon) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] prepared a "..spellLink, q, nil, r) end
				end
			end
		end
		if profile.RepairBot then
			if (event == "SPELL_CREATE" and spellID == 51710) or
			(event == "SPELL_SUMMON" and spellID == 67826 or spellID == 54711) then
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." used "..spellLinkColor..spellIcon) end
				if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] used "..spellLink, q, nil, r) end
			end
		end
		if profile.Fun and player.Name ~= sourceName then -- dont show yourself xD
			if (event == "SPELL_CAST_START" and spellID == 58493) or -- S 58493[Mohawked!]
			(event == "SPELL_AURA_APPLIED" and
			(spellID == 61834 or -- [Manabonked!] (NPC)
			spellID == 61819 or -- [Manabonked!] (Item)
			spellID == 60122 or -- [Baby Spice]
			((spellID == 55346 or -- [Dark Jade Beam]
			spellID == 56190 or -- [Shadow Crystal Focusing Lens]
			spellID == 56191) and destName ~= sourceName) or -- [Shadow Jade Focusing Lens]
			strfind(spellName, "Costume") or
			spellID == 27571 or -- [Cascade of Roses]  Love is in the Air
			spellID == 61815 or -- [Sprung!]  Noblegarden
			spellID == 44212 or -- [Jack-o'-Lanterned!]  Hallow's End
			spellID == 61781 or -- [Turkey Feathers]  Pilgrim's Bounty
			spellID == 44755)) or -- [Snowflakes]  Feast of Winter Veil
			(event == "SPELL_CREATE" and
			(spellID == 61031 or -- [Toy Train Set]
			spellID == 49844 or -- [Using Direbrew's Remote]
			spellID == 43808 or -- [Brewfest Pony Keg]
			spellID == 62857)) then -- [Sandbox Tiger]
				if spellID == 61031 or spellID == 49844 then SCM("["..sourceName2.."] used "..spellLink, announceType) -- Toy Train, Direbrew's Remote
				else
					if destName then a = " on "..destRT..destLink else a = "" end CF:AddMessage(datestamp1..sourceRT..sourceLink.." used "..spellLinkColor..spellIcon..a)
				end
			end
		end
	--	Class Ability
		if event == "SPELL_AURA_APPLIED" then
			if ((profile.abilityExcludeSelf and sourceName ~= player.Name) or not profile.abilityExcludeSelf) and
			((spellID == 20707 and profile.abilitySoulstone) or
			(spellID == 54646 and profile.abilityFocusMagic) or
			(spellID == 50720 and profile.abilityVigilance) or
			(spellID == 29166 and profile.abilityInnervate) or
			(spellID == 6346 and profile.abilityFearWard) or
			(spellID == 2096 and profile.abilityMindVision and destName ~= sourceName)) then
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." cast "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				if chatChannel>1 and spellID ~= 2096 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] cast "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
			end
		-- quick and dirty [Misdirection] and [Tricks of the Trade] fix
		elseif event == "SPELL_CAST_SUCCESS" then
			if ((profile.abilityExcludeSelf and sourceName ~= player.Name) or not profile.abilityExcludeSelf) and
				((spellID == 34477 and profile.abilityMisdirection and destName ~= sourceName) or
				(spellID == 57934 and profile.abilityTricksTrade and destName ~= sourceName)) then
				if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." cast "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				if chatChannel>1 and spellID ~= 2096 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] cast "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
			end
		elseif event == "SPELL_CAST_SUCCESS" then
			if profile.abilityBloodlust and ((spellID == 32182 or spellID == 2825 or spellID == 80353) and Time > cd.Bloodlust) or
			(spellID == 43987 and profile.abilityRitualRefreshment and Time > cd.RitualRefreshment) then
				if spellID == 32182 or spellID == 2825 or spellID == 80353 then cd.Bloodlust = Time + 130 -- set cooldowns
				elseif spellID == 43987 then cd.RitualRefreshment = Time + 130 end
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then SCM("["..sourceName2.."] cast "..spellLink, "BATTLEGROUND") -- Heroism/Bloodlust/Timewarp "wasted" before bg starts; Ritual of Refreshment
				else
					if chatWindow>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." cast "..spellLinkColor..spellIcon) end
					if chatChannel>1 and Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] cast "..spellLink, q, nil, r) end
				end
			end
		end
	end
end